# -*- coding: cp1250 -*-
import pygame, random
from function import *
from constants import *
import ui

WIDTH = 800
HEIGHT = 600
WHITE = (255,255,255)
LIGHT_BLUE = (100,100,200)
BLACK = (0,0,0)
KEYS = [[K_w, K_a, K_s, K_d, K_TAB],
        [K_i, K_j, K_k, K_l, K_n]]
MAXSPEED = 18
ACC = 1
HUMANS = 2 #max 2 or add to KEYS above
COMPS = 1
class Atractor:
    def __init__(self, x,y, power):
        self.rect = pygame.Rect(x,y, 1, 1)
        self.power = power
class Player:
    def __init__(self, axis, comp = False):
        self.image = load_random_image()
        self.rect = self.image.get_rect()
        self.rect.topleft = axis
        self.xspeed = 0
        self.yspeed = 0
        self.comp = comp
        if not self.comp:
            self.border = load_image("rect1.png", -1, True)
            self.image.blit(self.border, self.rect)
        
    def move(self, u, l, d, r):
        if l:
            self.xspeed -= ACC
        if r:
            self.xspeed += ACC
        if d:
            self.yspeed += ACC
        if u:
            self.yspeed -= ACC
        if ((self.xspeed)**2 + (self.yspeed)**2)**0.5 > MAXSPEED:
            k = float(MAXSPEED / (((self.xspeed)**2 + (self.yspeed)**2)**0.5))
            self.xspeed *= k
            self.yspeed *= k
        """if abs(self.xspeed) > MAXSPEED:
            self.xspeed = MAXSPEED*(self.xspeed/abs(self.xspeed))
        if abs(self.yspeed) > MAXSPEED:
            self.yspeed = MAXSPEED*(self.yspeed/abs(self.yspeed))"""
        self.rect.x += self.xspeed
        if self.rect.x < 0:
            self.rect.x = 0
            self.xspeed = -self.xspeed
        if self.rect.right > WIDTH:
            self.rect.right = WIDTH-1
            self.xspeed = -self.xspeed
        self.rect.y += self.yspeed
        if self.rect.y < 0:
            self.rect.y = 0
            self.yspeed = -self.yspeed
        if self.rect.bottom > HEIGHT:
            self.rect.bottom = HEIGHT-1
            self.yspeed = -self.yspeed
class Planees:
    def __init__(self):
        self.screen = pygame.display.set_mode((WIDTH,HEIGHT))
        self.screen.fill(WHITE)
        self.bg = self.screen.copy()
        running = True
        c = pygame.time.Clock()
        atractors = []
        """border = 0
        bpower = 0"""
        atractors.append(Atractor(WIDTH/2 , HEIGHT/2,1.0))
        """atractors.append(Atractor(border , border,bpower))
        atractors.append(Atractor(WIDTH-border , border,bpower))
        atractors.append(Atractor(border, HEIGHT-border,bpower))
        atractors.append(Atractor(WIDTH-border , HEIGHT-border,bpower))"""
        chars = []
        uis = []
        for i in range(HUMANS + COMPS):
            chars.append(Player((random.randint(0,8)*100,random.randint(0,6)*100), True))
        for i in range(COMPS):
            uis.append(ui.Ui(chars[i].rect.center, (WIDTH/2, HEIGHT/2)))
        if True:
            tendencies = []
            for i in range(COMPS):
                tendencies.append([])
            for i in range(HUMANS + COMPS):
                if i < COMPS:
                    total_tends = 0
                    for atr in atractors:
                        tendencies[i].append([atr.rect, atr.power])
                    for o in range(HUMANS + COMPS):
                        if o != i:
                            tendency = float((random.randint(1,1)-0.4)*5.0 - total_tends)
                            total_tends += tendency
                            print i, tendency
                            tendencies[i].append([chars[o].rect, tendency])
                            if o < COMPS:
                                tendencies[o].append([chars[i].rect, -tendency])


        time = pygame.time.get_ticks() / 100
        while running:
            c.tick(20)
            for e in pygame.event.get():
                if e.type == pygame.QUIT:
                    running = False
                if e.type == pygame.KEYDOWN and e.key == pygame.K_ESCAPE:
                    running = False
            key = pygame.key.get_pressed()
            # generuj seznam pro ui
            for i in range(HUMANS + COMPS):
                if i < COMPS:
                    tends = []
                    for tendence in tendencies[i]:
                        tends.append([tendence[0].center, tendence[1]])
                    u, l, d, r = uis[i].move(chars[i].rect.center, tends)
                    chars[i].move(u, l, d, r)
                else:
                    hi = i - COMPS
                    chars[i].move(key[KEYS[hi][0]], key[KEYS[hi][1]], key[KEYS[hi][2]], key[KEYS[hi][3]])
                            
            """tendencies = [[chars[1].rect.center, 5.0],[(320,240), 0.5]]
            u, l, d, r = ui1.move(chars[0].rect.center, tendencies)
            chars[0].move(u, l, d, r)
            tendencies = [[chars[0].rect.center, -5.0],[(320,240), 0.5]]
            u, l, d, r = ui2.move(chars[1].rect.center, tendencies)
            chars[1].move(u, l, d, r)
            char1.move(key[KEYS[0][0]], key[KEYS[0][1]], key[KEYS[0][2]], key[KEYS[0][3]])
            char2.move(key[KEYS[2][0]], key[KEYS[2][1]], key[KEYS[2][2]], key[KEYS[2][3]])"""
            for i in range(len(chars)):
                for o in range(len(chars)):
                    if o != i:                        
                        if chars[o].rect.colliderect(chars[i].rect):
                            print (pygame.time.get_ticks() / 100 - time) / 10., 's'
                            running = False
            for i in chars:
                self.screen.blit(i.image, i.rect.topleft)
            #self.screen.blit(char2.image, char2.rect.topleft)
            pygame.display.flip()
            for i in chars:
                self.screen.blit(self.bg.subsurface(i.rect), i.rect.topleft)
            #self.screen.blit(self.bg.subsurface(char2.rect), char2.rect.topleft)"""
            
    
if __name__ == "__main__":
    pygame.init()
    Planees()
    pygame.quit()
